Subject: [Json] Normative reference reasoning and logistics

From: Tim Bray <[email-masked]>
Date: Sat, 14 Nov 2015 11:10:47 -0800

Our charter says we are to consider inserting a normative reference to
ECMA-404 into an RFC7159bis.  There is a problem in that the definition of
“normative reference” is clear (I won't read it off yet again) and there's
no way ECMA-404 qualifies.

You could make a case that the reference is useful because 404 allows all
the things 7159 warns against, but implementors would be better served by a
simple assertion that “404 allows all the things 7159 warns against”.

In fact, I'm deeply unconvinced that consulting -404 is useful for anyone
in any circumstance, because it doesn't change the definition of what a
“JSON text” is from that found in 7159 and all its predecessors.

So, is there a *real* reason why a normative reference might be useful? I
think there might be, and it's purely rhetorical (in the formal sense,
designed to support an argument): To make it clear to the world that all
JSON is the same JSON no matter where it's specified.  So I think it would
be plausible to add the following to the second paragraph of section 1.2 of
7159 (for convenience: http://rfc7159.net/rfc7159#rfc.section.1.2 ):

“The reference to ECMA-404 in the previous sentence is normative, not with
the usual meaning that implementors need to consult it in order to
understand this document, but to emphasize that there are no
inconsistencies in the definition of the term “JSON text” in any of its
specifications. Note, however, that ECMA-404 allows several practices which
this specification recommends avoiding in the interests of maximal
interoperability.”

But I have a practical question. What exact effect to we expect this to
have?  Will ECMA-404 be updated in place with a reference to 7159bis (ECMA
specs can be updated in place, because -404 already has been, to remove a
silly typo).  Will there be an ECMA-404bis, and if so, should we work
carefully with ECMA to make sure that the two -bis specs mutually reference
each other?

---

From: "Peter F. Patel-Schneider" <[email-masked]>
Date: Sat, 14 Nov 2015 11:35:33 -0800

On 11/14/2015 11:10 AM, Tim Bray wrote:

[...]

> designed to support an argument): To make it clear to the world that all JSON
> is the same JSON no matter where it's specified.  So I think it would be
> plausible to add the following to the second paragraph of section 1.2 of 7159
> (for convenience: http://rfc7159.net/rfc7159#rfc.section.1.2 ):
> 
> “The reference to ECMA-404 in the previous sentence is normative, not with the
> usual meaning that implementors need to consult it in order to understand this
> document, but to emphasize that there are no inconsistencies in the definition
> of the term “JSON text” in any of its specifications. Note, however, that
> ECMA-404 allows several practices which this specification recommends avoiding
> in the interests of maximal interoperability.”

I don't see any utility in making the reference normative, particularly if
wording along the lines of  "There are no differences in the definition
of the term ``JSON text'' between this specification and ECMA-404 [informative
reference].  There is no intent to allow the two specifications to diverge in
the future on what is allowable for JSON text." is in 7159bis.  This wording
seems to be adequate support for what I think everyone hopes is the case.

peter

PS:  Is there any formal definition for the railroad tracks in ECMA-404?

---

From: "Joe Hildebrand (jhildebr)" <[email-masked]>
Date: Tue, 17 Nov 2015 09:10:45 +0000

On 11/14/15, 8:10 PM, "json on behalf of Tim Bray" <[email-masked] on behalf of [email-masked]> wrote:

>But I have a practical question. What exact effect to we expect this to have?  Will ECMA-404 be updated in place with a reference to 7159bis (ECMA specs can be updated in place, because -404 already has been,
> to remove a silly typo).  Will there be an ECMA-404bis, and if so, should we work carefully with ECMA to make sure that the two -bis specs mutually reference each other?

My understanding is that this is the intent.  A normative reference makes roughly the same amount of sense in the other direction (i.e. Perhaps none, depending on your point of view), but that we have pre-discussed with the -404 team this potential approach for moving forward.

Our ECMA liaison might want to speak more formally to this point.

-- 
Joe Hildebrand

---

From: "Matt Miller (mamille2)" <[email-masked]>
Date: Tue, 17 Nov 2015 15:16:20 +0000

> On Nov 17, 2015, at 02:10, Joe Hildebrand (jhildebr) <[email-masked]> wrote:
> 

This is what's been discussed with Ecma TC39.  They will update 404 to include a reference to 7159bis when it completes.  As everyone surmises, no further changes are expected in either documents.

--
- m&m

Matt Miller <[email-masked]>
Cisco Systems, Inc.